searchNodes=[{"ref":"CredoNaming.Check.Consistency.ModuleFilename.html","title":"CredoNaming.Check.Consistency.ModuleFilename","type":"module","doc":"This check has a base priority of low and works with any version of Elixir. Explanation If a file contains a single module, its filename should match the name of the module. # preferred # lib/foo/bar.exs defmodule Foo.Bar, do: nil # lib/foo/bar/bar.exs defmodule Foo.Bar, do: nil # lib/foo/foo.exs defmodule Foo, do: nil # lib/foo.exs defmodule Foo, do: nil # lib/foo/exceptions.exs defmodule Foo.FirstException, do: nil defmodule Foo.SecondException, do: nil # NOT preferred # lib/foo.exs defmodule Bar, do: nil # lib/foo/schemas/bar.exs defmodule Foo.Bar, do: nil Configuration parameters Use the following parameters to configure this check: excluded_paths: A list of paths to exclude Defaults to [] acronymes: A list of tuples that map a module term to its path version, eg. [{&quot;MyAppGraphQL&quot;, &quot;myapp_graphql&quot;}] Defaults to nil valid_filename_callback: A function (either &amp;fun/3 or {module, fun}) that will be called on each filename with the name of the module it defines Defaults to {nil, :valid_filename?} Parameters can be configured via the .credo.exs config file."},{"ref":"CredoNaming.Check.Consistency.ModuleFilename.html#root_path/1","title":"CredoNaming.Check.Consistency.ModuleFilename.root_path/1","type":"function","doc":"Returns the root path of a file, with support for umbrella projects"},{"ref":"CredoNaming.Check.Consistency.ModuleFilename.html#valid_filename?/3","title":"CredoNaming.Check.Consistency.ModuleFilename.valid_filename?/3","type":"function","doc":"Returns whether the filename matches the module defined in it."},{"ref":"CredoNaming.Check.Warning.AvoidSpecificTermsInModuleNames.html","title":"CredoNaming.Check.Warning.AvoidSpecificTermsInModuleNames","type":"module","doc":"This check has a base priority of low and works with any version of Elixir. Explanation In an effort to encourage more accurate module naming practices, it is sometimes useful to maintain a list of terms to avoid in module names. For example, if the list of terms to avoid is [&quot;Manager&quot;, &quot;Fetcher&quot;]: # preferred defmodule Accounts do end defmodule App.Networking do end # NOT preferred defmodule AccountManager do end defmodule App.DataFetcher do end Configuration parameters Use the following parameters to configure this check: terms: A list of terms to avoid Defaults to [] Parameters can be configured via the .credo.exs config file."},{"ref":"CredoNaming.Check.Warning.AvoidSpecificTermsInModuleNames.html#traverse/4","title":"CredoNaming.Check.Warning.AvoidSpecificTermsInModuleNames.traverse/4","type":"function","doc":""},{"ref":"readme.html","title":"README","type":"extras","doc":"CredoNaming is a suite of checks to enforce naming best practices in an Elixir project."},{"ref":"readme.html#installation","title":"README - Installation","type":"extras","doc":"Add the :credo_naming package to your mix.exs dependencies: def deps do [ {:credo_naming, &quot;~&gt; 0.5&quot;, only: [:dev, :test], runtime: false} ] end"},{"ref":"readme.html#usage","title":"README - Usage","type":"extras","doc":"You just need to add the checks you want in your .credo.exs configuration file. Avoid specific terms in module names This check will raise an issue if specific terms are found in module names. {CredoNaming.Check.Warning.AvoidSpecificTermsInModuleNames, terms: [&quot;Manager&quot;, ~r/Helpers?/]} Suppose you have a MyApp.ErrorHelpers module: $ mix credo ┃ Warnings - please take a look ┃ ┃ [W] ↘ `Helpers` is included in the list of terms to avoid in module names. ┃ Consider replacing it with a more accurate one. ┃ lib/my_app/error_helpers.ex:1:39 #(MyApp.ErrorHelpers) With this check configuration for example, a module named MyApp.UserManager or MyApp.FormHelpers would not be allowed. Ensure module/filename consistency This check will raise an issue if the name of a module defined in a file does not match its filename. {CredoNaming.Check.Consistency.ModuleFilename} Suppose you have a lib/foo.ex file that defines a Bar module: $ mix credo ┃ Consistency ┃ ┃ [C] ↘ The module defined in `lib/foo.ex` is not named consistently with the ┃ filename. The file should be named either: ┃ ┃ [&quot;lib/bar/bar.ex&quot;, &quot;lib/bar.ex&quot;] ┃ ┃ lib/foo.ex:1:11 #(Bar) Exclusions You can exclude files or paths with the excluded_paths option: {CredoNaming.Check.Consistency.ModuleFilename, excluded_paths: [&quot;test/support&quot;, &quot;priv&quot;, &quot;rel&quot;, &quot;mix.exs&quot;]} Acronyms The check converts module names to paths using PascalCase convention, which means that the file lib/myapp_graphql.ex is expected to define the module: defmodule MyappGraphql do end If you want to define your own acronyms, you can do so using the acronyms option: {CredoNaming.Check.Consistency.ModuleFilename, acronyms: [{&quot;MyAppGraphQL&quot;, &quot;myapp_graphql&quot;}]} Using this, the lib/myapp_graphql.ex file will expect to define the module: defmodule MyAppGraphQL do end Naming conventions By default, the check allows for a specific list of valid filenames when a single module is declared within a file. You can overwrite this behaviour by providing the valid_filename_callback option and implement yourself if a filename should be considered valid. The callback receives three arguments: filename, the stringified name of the module contained in the file (eg. &quot;lib/my_app/foo/bar.ex&quot;) module_name, the stringified name of the module contained in the file (eg. &quot;MyApp.Foo.Bar&quot;) opts, the options list passed to the check (eg. [acronyms: [{&quot;GraphQL&quot;, &quot;graphql&quot;}]]) And must return a tuple containing a boolean value (if the filename is considered valid) and a list of expected filenames. In this (very simple) example, a file lib/my_app/wrong.ex that defines a MyApp.Foo.Bar module would return a {false, [&quot;lib/my_app/foo/bar.ex&quot;]} tuple. def valid_filename?(filename, module_name, _opts) do root_path = CredoNaming.Check.Consistency.ModuleFilename.root_path(filename) path = &quot;\#{Macro.underscore(module_name)}\#{Path.extname(filename)}&quot; filenames = [ Path.join([root_path, path]) ] {filename in filenames, filenames} end {CredoNaming.Check.Consistency.ModuleFilename, valid_filename_callback: &amp;valid_filename/3} You could also use the callback to ignore specific files and fallback on the default callback for others. def valid_filename?(&quot;lib/my_app/my_specific_file.ex&quot;, _module_name, _opts), do: {true, []} def valid_filename?(&quot;lib/my_app/my_other_specific_file.ex&quot;, _module_name, _opts), do: {true, []} def valid_filename?(filename, module_name, opts), do: CredoNaming.Check.Consistency.ModuleFilename.valid_filename?(filename, module_name, opts) {CredoNaming.Check.Consistency.ModuleFilename, valid_filename_callback: &amp;valid_filename/3} In the future, there may be some “naming convention flavours” (eg. :default, :phoenix, etc.) to use instead of having to implement your own callback."},{"ref":"readme.html#contributors","title":"README - Contributors","type":"extras","doc":"Rémi Prévost (@remiprev) Tomáš Janoušek (@liskin)"},{"ref":"readme.html#license","title":"README - License","type":"extras","doc":"CredoNaming is © 2019 Mirego and may be freely distributed under the New BSD license. See the LICENSE.md file. The tag logo is based on this lovely icon by Vectors Point, from The Noun Project. Used under a Creative Commons BY 3.0 license."},{"ref":"readme.html#about-mirego","title":"README - About Mirego","type":"extras","doc":"Mirego is a team of passionate people who believe that work is a place where you can innovate and have fun. We’re a team of talented people who imagine and build beautiful Web and mobile applications. We come together to share ideas and change the world. We also love open-source software and we try to give back to the community as much as we can."}]